#!/usr/bin/ruby

require "rexml/document"

kversion = ` uname -r `.strip

# read usb database
usb_database = File.new("/lib/modules/" + kversion + "/modules.usbmap").readlines

# read pci database
pci_database = File.new("/lib/modules/" + kversion + "/modules.pcimap").readlines

usb_map = Hash.new
pci_map = Hash.new

usb_database.each { |l|
	unless l =~ /^#/
		tokens = l.split
		modu = tokens[0]
		vend = tokens[2].to_i(16)
		prod = tokens[3].to_i(16)
		unless usb_map.has_key? vend
			usb_map[vend] = Hash.new
		end
		unless usb_map[vend].has_key? prod
			usb_map[vend][prod] = Array.new
		end
		usb_map[vend][prod].push(modu)
	end
}

IO.popen("lsusb") { |l|
	while l.gets
		toks = $_.split
		v = toks[5].split(":")[0]
		i = toks[5].split(":")[1]
		begin
			unless v.to_i(16) * i.to_i(16) == 0
				puts v + ":" + i + " loading: " + usb_map[v.to_i(16)][i.to_i(16)].join(" ")
				usb_map[v.to_i(16)][i.to_i(16)].each { |m|
					system("modprobe -b -v " + m)
				}
			end
		rescue
		end
	end
}

pci_database.each { |l|
	unless l =~ /^#/
		tokens = l.split
		modu = tokens[0]
		vend = tokens[1].to_i(16)
		prod = tokens[2].to_i(16)
		unless pci_map.has_key? vend
			pci_map[vend] = Hash.new
		end
		unless pci_map[vend].has_key? prod
			pci_map[vend][prod] = Array.new
		end
		pci_map[vend][prod].push(modu)
	end
}

IO.popen("lspci -n") { |l|
	while l.gets
		toks = $_.split
		v = toks[2].split(":")[0]
		i = toks[2].split(":")[1]
		begin
			unless v.to_i(16) * i.to_i(16) == 0
				puts v + ":" + i + " loading: " + pci_map[v.to_i(16)][i.to_i(16)].join(" ")
				pci_map[v.to_i(16)][i.to_i(16)].each { |m|
					system("modprobe -b -v " + m)
				}
			end
		rescue
		end
	end
}


